window.settings = window.domElements = window.objects = window.utils = window.variables = window.globals = {};
objects.intro = objects.game = objects.records = objects.server = undefined;
variables.playerName = variables.currentMoney = undefined;

variables.TWO_SAME_TEXT = "2 SAME!";
variables.THREE_SAME_TEXT = "3 SAME!!!";
variables.THREE_OF_TYPE_TEXT = "3 Of Type!";
variables.NO_WIN_TEXT = "No money won";
variables.SLOT_IMAGES = undefined;
variables.SLOT_STOPPED_EVENT = "slot_stopped";
variables.SLOT_ROTATION_ENDED = "slot_rotation_ended";
variables.loadedImages = undefined;

domElements.$introScreen = $("#intro_screen");
domElements.$gameScreen = $("#game_screen");
domElements.$recordScreen = $("#records_screen");
domElements.$activeScreen = undefined;
domElements.$slots = $(".slots")
domElements.invisibleClassName = "invisible";
domElements.slotDivClass = "slot_div";
domElements.slotImageClass = "slot_image";
domElements.slotImageSpace = 10;
domElements.shinySlotClass = "shiny_slot";
domElements.$preloader = $("#preloader");
domElements.$gameNameH1 = $("#game_name_h1");

utils.turnOnScreen = function($screen) {
    var $oldScreen, newZIndex;
    newZIndex = 3;
    if (typeof domElements.$activeScreen !== "undefined") {
        $oldScreen = domElements.$activeScreen;
        newZIndex = parseInt($oldScreen.css("z-index")) + 1;
    }
    domElements.$activeScreen = $screen;
    $screen.css("z-index", newZIndex);
    $screen.css("left", $(window).width() * -1);
    $screen.animate({left: 0}, settings.ANIMATION_DURATION, "swing", function() {
        if (($oldScreen != null)) $oldScreen.css({"left": "-2000px"});
    });
};

utils.setResizeListener = function() {
    $(window).resize(function (e) {
        utils.resizeSlots()
    });
	ScreenResize();

}

utils.resizeSlots = function() {
    domElements.$slots.height(domElements.$slots.width());
    for(var i = 0; i < objects.game.slots.length; i++) {
        objects.game.slots[i].resizeImages(domElements.$slots.height());
    }
}

utils.getRandomIcon = function() {
    var index = Math.round(Math.random() * (settings.icons.length - 1));
    return settings.icons[index];
}

utils.getSameTypeIcon = function (icon) {
    var tempIcon = utils.getRandomIcon();
    if(tempIcon[settings.typeParameter] != icon[settings.typeParameter]) {
        return utils.getSameTypeIcon(icon);
    }
    return tempIcon;
}

utils.getSameTypeButDifferentIcon = function (icon) {
    var tempIcon = utils.getRandomIcon();
    if(tempIcon[settings.typeParameter] != icon[settings.typeParameter] && tempIcon[settings.imageParameter] == icon[settings.imageParameter]) {
        return utils.getSameTypeButDifferentIcon(icon);
    }
    return tempIcon;
}

utils.getDifferentIcon = function (icon) {
    var tempIcon = utils.getRandomIcon();
    if(tempIcon[settings.typeParameter] == icon[settings.typeParameter] || tempIcon[settings.imageParameter] == icon[settings.imageParameter]) {
        return utils.getDifferentIcon(icon);
    }
    return tempIcon;
}

utils.getDifferentOfTwoIcon = function (icon1, icon2) {
    var tempIcon = utils.getRandomIcon();
    if(tempIcon[settings.typeParameter] == icon1[settings.typeParameter] || tempIcon[settings.imageParameter] == icon1[settings.imageParameter]
            || tempIcon[settings.typeParameter] == icon2[settings.typeParameter] || tempIcon[settings.imageParameter] == icon2[settings.imageParameter]) {
        return utils.getDifferentOfTwoIcon(icon1, icon2);
    }
    return tempIcon;
}