function Slot(parentDiv, upperDiv) {
    this.$parentDiv = parentDiv;
    this.$upperDiv = upperDiv;
    this.slotDivs = this.slotImages = undefined;
    this.totalHeight = undefined;
    this.targetIndex = undefined;
    this.targetIcon = undefined;
    this.needToShine = false;
    this.setPictures();
    this.index = Math.round(Math.random() * (this.slotDivs.length / 2 - 1));
    this.setToIndex();
}

Slot.prototype.setPictures = function() {
    this.slotDivs = new Array();
    this.slotImages = new Array();
    this.setOneColumn();
    this.setOneColumn();
}

Slot.prototype.setOneColumn = function() {
    for(var i = 0; i < variables.SLOT_IMAGES.length; i++) {
        var div = $("<div>", {"class" : domElements.slotDivClass});
        var img = $("<img>", {"class" : domElements.slotImageClass, "src" : variables.SLOT_IMAGES[i].src});
        div.append(img);
        this.$parentDiv.append(div);
        this.slotImages.push(img);
        this.slotDivs.push(div);
    }
}

Slot.prototype.rotate = function() {
    this.$upperDiv.removeClass(domElements.shinySlotClass);
    var currentMargin = parseInt(this.$parentDiv.css("margin-top").replace("px",""));
    this.$parentDiv.css("margin-top", (currentMargin - this.totalHeight) + "px");
    slot = this;
    this.$parentDiv.animate({"margin-top": currentMargin}, settings.SPIN_TIME, "linear", function() {
        $(slot).trigger(variables.SLOT_STOPPED_EVENT);
    });
}

Slot.prototype.setToTargetPlace = function() {
    this.targetIndex = settings.icons.indexOf(this.targetIcon);
    var timePerIcon = settings.SPIN_TIME / settings.icons.length;
    var targetMargin = domElements.$slots.height() * this.targetIndex * -1;
    var currentMargin = parseInt(this.$parentDiv.css("margin-top").replace("px",""));
    var timeToGo = undefined;
    if(this.targetIndex == this.index) {
        this.$parentDiv.css("margin-top", (currentMargin - this.totalHeight) + "px");
        timeToGo = settings.SPIN_TIME;
    }else if(this.targetIndex > this.index) {
        this.$parentDiv.css("margin-top", (currentMargin - this.totalHeight) + "px");
        timeToGo = (this.index + settings.icons.length - this.targetIndex) * timePerIcon;
    }else if(this.targetIndex < this.index) {
        timeToGo = (this.index - this.targetIndex) * timePerIcon;
    }
    var slot = this;
    this.$parentDiv.animate({"margin-top": targetMargin}, timeToGo, "easeOutSine", function(e){
        if(slot.needToShine == true) slot.$upperDiv.addClass(domElements.shinySlotClass);
        slot.needToShine = false;
        $(slot).trigger(variables.SLOT_ROTATION_ENDED);
    });
}

Slot.prototype.setToIndex = function() {
    var slotSize = domElements.$slots.height();
    var margin = 0 - this.index * slotSize;
    this.$parentDiv.css("margin-top", margin + "px");
}

Slot.prototype.resizeImages = function(size) {
    for (var i = 0; i < this.slotImages.length; i++) {
        this.slotDivs[i].width(size);
        this.slotDivs[i].height(size);
    }
    this.setToIndex();
    this.totalHeight = size * this.slotDivs.length / 2;
}